package main

import (
	"flag"
	"fmt"
	"net/http"
	"strconv"
)

func title() {
	fmt.Println("\n  _     _   _         _               _")
	fmt.Println(" | |__ | |_| |_ _ __ (_) ___ ___ ___ | | ___")
	fmt.Println(" | '_ \\| __| __| '_ \\| |/ __/ __/ _ \\| |/ _ \\")
	fmt.Println(" | | | | |_| |_| |_) | | (_| (_| (_) | | (_) |")
	fmt.Println(" |_| |_|\\__|\\__| .__/|_|\\___\\___\\___/|_|\\___/")
	fmt.Println("               |_|                            \n")
	fmt.Println("    small static http server - version 0.1")
	fmt.Println("             by Marcello Zaniboni\n")
}

func license() {
	fmt.Println("marcello.zaniboni@gmail.com, mzaniboni@hotmail.com\n")
	fmt.Println("This program is free software; you can redistribute it and/or")
	fmt.Println("modify it under the terms of the GNU General Public License as")
	fmt.Println("published by the Free Software Foundation; either version 2")
	fmt.Println("of the License, or (at your option) any later version.")
	fmt.Println("You should have received a copy of the GNU General Public")
	fmt.Println("License along with this program (file \"LICENSE.txt\"); if not,")
	fmt.Println("visit www.gnu.org/licenses/old-licenses/gpl-2.0.html\n")
	fmt.Println("This program is distributed in the hope that it will be useful,")
	fmt.Println("but WITHOUT ANY WARRANTY; without even the implied warranty of")
	fmt.Println("MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the")
	fmt.Println("GNU General Public License for more details.")
}

func main() {

	title()

	rootPtr := flag.String("root", "./www", "the root directory")
	portPtr := flag.Int("p", 8080, "port number")
	licensePtr := flag.Bool("l", false, "show license terms")
	flag.Parse()

	if *licensePtr {
		license()
		return
	}

	fmt.Println("Started:")
	fmt.Println(" - root directory:", *rootPtr)
	fmt.Println(" - port number:", *portPtr)
	fmt.Println("\nRun \"httpiccolo -h\" to show usage information.")
	fmt.Println("Press Ctrl + C to stop, or kill with SIGHUP / SIGTERM.")

	http.Handle("/", http.FileServer(http.Dir(*rootPtr)))

	if err := http.ListenAndServe(":"+strconv.Itoa(*portPtr), nil); err != nil {
		panic(err)
	}
}
